<template>
    <div v-loading="loading" class="hc-body-loading" element-loading-text="授权登录中...">
        <div v-if="isErrorShow" class="error-page">
            <div class="img" :style="`background-image: url(${svg403});`" />
            <div class="content">
                <h1>403</h1>
                <div class="desc">抱歉，token授权登录异常，请重新进入</div>
                <div class="actions">
                    <el-button type="primary" block size="large" @click="toLoginTap">手动登录</el-button>
                </div>
            </div>
        </div>
    </div>
</template>

<script setup>
import { onMounted, ref } from 'vue'
import { getTenantID } from '~api/user'
import { useAppStore } from '~src/store'
import { setUserTenantInfo, useAppLogin } from '~sto/user'
import { useRoute, useRouter } from 'vue-router'
import { getObjVal, getObjValue, isNullES } from 'js-fast-way'

import svg403 from '~src/assets/view/403.svg'
import userApi from '~api/userInfo'
import { getTopUrl } from '~uti/tools'

//初始变量
const router = useRouter()
const useRoutes = useRoute()
const store = useAppStore()

//变量
const loading = ref(true)
const isErrorShow = ref(false)

//渲染完成
onMounted(() => {
    //先清理下缓存
    store.clearStoreData()
    // 域名后加  /#/auth?token=xxxxxxx&tenantid=xxxxxxx
    const { token, tenantid } = getObjValue(useRoutes.query)
    if (token) {
        isErrorShow.value = false
        store.setTokenVal(token)
        queryCurrentUserData(tenantid)
    } else {
        loading.value = false
        isErrorShow.value = true
    }
})

//获取租户id
const getTenantIdApi = async () => {
    const { data } = await getTenantID(getTopUrl())
    const { id } = await setUserTenantInfo(getObjVal(data))
    return id
}

//获取用户信息
const queryCurrentUserData = async (tenant_id) => {
    await getTenantIdApi()
    const tenantIds = await getTenantIdApi()
    const tenantId = tenant_id ? tenant_id : tenantIds
    const { error, code, data } = await userApi.queryCurrentUserData()
    if (!error && code === 200) {
        await useAppLoginApi({
            tenantId: tenantId,
            username: data.account,
            password: data.plaintextPassword,
            type: 'account',
        })
    } else {
        window.$message?.error('授权信息异常')
        isErrorShow.value = true
        loading.value = false
    }
}

//请求授权登录
const useAppLoginApi = async (form) => {
    loading.value = true
    const { error, msg } = await useAppLogin(form)
    if (error && !isNullES(msg)) {
        window.$message?.error('授权登录失败')
        isErrorShow.value = true
        loading.value = false
        return false
    }
    //授权登录成功
    setTimeout(() => {
        loading.value = false
        isErrorShow.value = false
        window?.$message?.success('授权登录成功')
        router.push({
            name: store.homeUrl ?? 'home',
        })
    }, 1500)
}

//跳转登陆
const toLoginTap = () => {
    router.push({ path: '/login' })
}
</script>

<style lang="scss" scoped>
@import "../../styles/error/style.scss";
.hc-body-loading {
    position: relative;
    height: 100%;
    width: 100%;
}
</style>
